{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-duplicate-exports #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.S3.Lens
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.S3.Lens
  ( -- * Operations

    -- ** AbortMultipartUpload
    abortMultipartUpload_expectedBucketOwner,
    abortMultipartUpload_requestPayer,
    abortMultipartUpload_bucket,
    abortMultipartUpload_key,
    abortMultipartUpload_uploadId,
    abortMultipartUploadResponse_requestCharged,
    abortMultipartUploadResponse_httpStatus,

    -- ** CompleteMultipartUpload
    completeMultipartUpload_checksumCRC32,
    completeMultipartUpload_checksumCRC32C,
    completeMultipartUpload_checksumSHA1,
    completeMultipartUpload_checksumSHA256,
    completeMultipartUpload_expectedBucketOwner,
    completeMultipartUpload_multipartUpload,
    completeMultipartUpload_requestPayer,
    completeMultipartUpload_sSECustomerAlgorithm,
    completeMultipartUpload_sSECustomerKey,
    completeMultipartUpload_sSECustomerKeyMD5,
    completeMultipartUpload_bucket,
    completeMultipartUpload_key,
    completeMultipartUpload_uploadId,
    completeMultipartUploadResponse_bucket,
    completeMultipartUploadResponse_bucketKeyEnabled,
    completeMultipartUploadResponse_checksumCRC32,
    completeMultipartUploadResponse_checksumCRC32C,
    completeMultipartUploadResponse_checksumSHA1,
    completeMultipartUploadResponse_checksumSHA256,
    completeMultipartUploadResponse_eTag,
    completeMultipartUploadResponse_expiration,
    completeMultipartUploadResponse_key,
    completeMultipartUploadResponse_location,
    completeMultipartUploadResponse_requestCharged,
    completeMultipartUploadResponse_sSEKMSKeyId,
    completeMultipartUploadResponse_serverSideEncryption,
    completeMultipartUploadResponse_versionId,
    completeMultipartUploadResponse_httpStatus,

    -- ** CopyObject
    copyObject_acl,
    copyObject_bucketKeyEnabled,
    copyObject_cacheControl,
    copyObject_checksumAlgorithm,
    copyObject_contentDisposition,
    copyObject_contentEncoding,
    copyObject_contentLanguage,
    copyObject_contentType,
    copyObject_copySourceIfMatch,
    copyObject_copySourceIfModifiedSince,
    copyObject_copySourceIfNoneMatch,
    copyObject_copySourceIfUnmodifiedSince,
    copyObject_copySourceSSECustomerAlgorithm,
    copyObject_copySourceSSECustomerKey,
    copyObject_copySourceSSECustomerKeyMD5,
    copyObject_expectedBucketOwner,
    copyObject_expectedSourceBucketOwner,
    copyObject_expires,
    copyObject_grantFullControl,
    copyObject_grantRead,
    copyObject_grantReadACP,
    copyObject_grantWriteACP,
    copyObject_metadata,
    copyObject_metadataDirective,
    copyObject_objectLockLegalHoldStatus,
    copyObject_objectLockMode,
    copyObject_objectLockRetainUntilDate,
    copyObject_requestPayer,
    copyObject_sSECustomerAlgorithm,
    copyObject_sSECustomerKey,
    copyObject_sSECustomerKeyMD5,
    copyObject_sSEKMSEncryptionContext,
    copyObject_sSEKMSKeyId,
    copyObject_serverSideEncryption,
    copyObject_storageClass,
    copyObject_tagging,
    copyObject_taggingDirective,
    copyObject_websiteRedirectLocation,
    copyObject_bucket,
    copyObject_copySource,
    copyObject_key,
    copyObjectResponse_bucketKeyEnabled,
    copyObjectResponse_copyObjectResult,
    copyObjectResponse_copySourceVersionId,
    copyObjectResponse_expiration,
    copyObjectResponse_requestCharged,
    copyObjectResponse_sSECustomerAlgorithm,
    copyObjectResponse_sSECustomerKeyMD5,
    copyObjectResponse_sSEKMSEncryptionContext,
    copyObjectResponse_sSEKMSKeyId,
    copyObjectResponse_serverSideEncryption,
    copyObjectResponse_versionId,
    copyObjectResponse_httpStatus,

    -- ** CreateBucket
    createBucket_acl,
    createBucket_createBucketConfiguration,
    createBucket_grantFullControl,
    createBucket_grantRead,
    createBucket_grantReadACP,
    createBucket_grantWrite,
    createBucket_grantWriteACP,
    createBucket_objectLockEnabledForBucket,
    createBucket_objectOwnership,
    createBucket_bucket,
    createBucketResponse_location,
    createBucketResponse_httpStatus,

    -- ** CreateMultipartUpload
    createMultipartUpload_acl,
    createMultipartUpload_bucketKeyEnabled,
    createMultipartUpload_cacheControl,
    createMultipartUpload_checksumAlgorithm,
    createMultipartUpload_contentDisposition,
    createMultipartUpload_contentEncoding,
    createMultipartUpload_contentLanguage,
    createMultipartUpload_contentType,
    createMultipartUpload_expectedBucketOwner,
    createMultipartUpload_expires,
    createMultipartUpload_grantFullControl,
    createMultipartUpload_grantRead,
    createMultipartUpload_grantReadACP,
    createMultipartUpload_grantWriteACP,
    createMultipartUpload_metadata,
    createMultipartUpload_objectLockLegalHoldStatus,
    createMultipartUpload_objectLockMode,
    createMultipartUpload_objectLockRetainUntilDate,
    createMultipartUpload_requestPayer,
    createMultipartUpload_sSECustomerAlgorithm,
    createMultipartUpload_sSECustomerKey,
    createMultipartUpload_sSECustomerKeyMD5,
    createMultipartUpload_sSEKMSEncryptionContext,
    createMultipartUpload_sSEKMSKeyId,
    createMultipartUpload_serverSideEncryption,
    createMultipartUpload_storageClass,
    createMultipartUpload_tagging,
    createMultipartUpload_websiteRedirectLocation,
    createMultipartUpload_bucket,
    createMultipartUpload_key,
    createMultipartUploadResponse_abortDate,
    createMultipartUploadResponse_abortRuleId,
    createMultipartUploadResponse_bucket,
    createMultipartUploadResponse_bucketKeyEnabled,
    createMultipartUploadResponse_checksumAlgorithm,
    createMultipartUploadResponse_key,
    createMultipartUploadResponse_requestCharged,
    createMultipartUploadResponse_sSECustomerAlgorithm,
    createMultipartUploadResponse_sSECustomerKeyMD5,
    createMultipartUploadResponse_sSEKMSEncryptionContext,
    createMultipartUploadResponse_sSEKMSKeyId,
    createMultipartUploadResponse_serverSideEncryption,
    createMultipartUploadResponse_httpStatus,
    createMultipartUploadResponse_uploadId,

    -- ** DeleteBucket
    deleteBucket_expectedBucketOwner,
    deleteBucket_bucket,

    -- ** DeleteBucketAnalyticsConfiguration
    deleteBucketAnalyticsConfiguration_expectedBucketOwner,
    deleteBucketAnalyticsConfiguration_bucket,
    deleteBucketAnalyticsConfiguration_id,

    -- ** DeleteBucketCors
    deleteBucketCors_expectedBucketOwner,
    deleteBucketCors_bucket,

    -- ** DeleteBucketEncryption
    deleteBucketEncryption_expectedBucketOwner,
    deleteBucketEncryption_bucket,

    -- ** DeleteBucketIntelligentTieringConfiguration
    deleteBucketIntelligentTieringConfiguration_bucket,
    deleteBucketIntelligentTieringConfiguration_id,

    -- ** DeleteBucketInventoryConfiguration
    deleteBucketInventoryConfiguration_expectedBucketOwner,
    deleteBucketInventoryConfiguration_bucket,
    deleteBucketInventoryConfiguration_id,

    -- ** DeleteBucketLifecycle
    deleteBucketLifecycle_expectedBucketOwner,
    deleteBucketLifecycle_bucket,

    -- ** DeleteBucketMetricsConfiguration
    deleteBucketMetricsConfiguration_expectedBucketOwner,
    deleteBucketMetricsConfiguration_bucket,
    deleteBucketMetricsConfiguration_id,

    -- ** DeleteBucketOwnershipControls
    deleteBucketOwnershipControls_expectedBucketOwner,
    deleteBucketOwnershipControls_bucket,

    -- ** DeleteBucketPolicy
    deleteBucketPolicy_expectedBucketOwner,
    deleteBucketPolicy_bucket,

    -- ** DeleteBucketReplication
    deleteBucketReplication_expectedBucketOwner,
    deleteBucketReplication_bucket,

    -- ** DeleteBucketTagging
    deleteBucketTagging_expectedBucketOwner,
    deleteBucketTagging_bucket,

    -- ** DeleteBucketWebsite
    deleteBucketWebsite_expectedBucketOwner,
    deleteBucketWebsite_bucket,

    -- ** DeleteObject
    deleteObject_bypassGovernanceRetention,
    deleteObject_expectedBucketOwner,
    deleteObject_mfa,
    deleteObject_requestPayer,
    deleteObject_versionId,
    deleteObject_bucket,
    deleteObject_key,
    deleteObjectResponse_deleteMarker,
    deleteObjectResponse_requestCharged,
    deleteObjectResponse_versionId,
    deleteObjectResponse_httpStatus,

    -- ** DeleteObjectTagging
    deleteObjectTagging_expectedBucketOwner,
    deleteObjectTagging_versionId,
    deleteObjectTagging_bucket,
    deleteObjectTagging_key,
    deleteObjectTaggingResponse_versionId,
    deleteObjectTaggingResponse_httpStatus,

    -- ** DeleteObjects
    deleteObjects_bypassGovernanceRetention,
    deleteObjects_checksumAlgorithm,
    deleteObjects_expectedBucketOwner,
    deleteObjects_mfa,
    deleteObjects_requestPayer,
    deleteObjects_bucket,
    deleteObjects_delete,
    deleteObjectsResponse_deleted,
    deleteObjectsResponse_errors,
    deleteObjectsResponse_requestCharged,
    deleteObjectsResponse_httpStatus,

    -- ** DeletePublicAccessBlock
    deletePublicAccessBlock_expectedBucketOwner,
    deletePublicAccessBlock_bucket,

    -- ** GetBucketAccelerateConfiguration
    getBucketAccelerateConfiguration_expectedBucketOwner,
    getBucketAccelerateConfiguration_bucket,
    getBucketAccelerateConfigurationResponse_status,
    getBucketAccelerateConfigurationResponse_httpStatus,

    -- ** GetBucketAcl
    getBucketAcl_expectedBucketOwner,
    getBucketAcl_bucket,
    getBucketAclResponse_grants,
    getBucketAclResponse_owner,
    getBucketAclResponse_httpStatus,

    -- ** GetBucketAnalyticsConfiguration
    getBucketAnalyticsConfiguration_expectedBucketOwner,
    getBucketAnalyticsConfiguration_bucket,
    getBucketAnalyticsConfiguration_id,
    getBucketAnalyticsConfigurationResponse_analyticsConfiguration,
    getBucketAnalyticsConfigurationResponse_httpStatus,

    -- ** GetBucketCors
    getBucketCors_expectedBucketOwner,
    getBucketCors_bucket,
    getBucketCorsResponse_cORSRules,
    getBucketCorsResponse_httpStatus,

    -- ** GetBucketEncryption
    getBucketEncryption_expectedBucketOwner,
    getBucketEncryption_bucket,
    getBucketEncryptionResponse_serverSideEncryptionConfiguration,
    getBucketEncryptionResponse_httpStatus,

    -- ** GetBucketIntelligentTieringConfiguration
    getBucketIntelligentTieringConfiguration_bucket,
    getBucketIntelligentTieringConfiguration_id,
    getBucketIntelligentTieringConfigurationResponse_intelligentTieringConfiguration,
    getBucketIntelligentTieringConfigurationResponse_httpStatus,

    -- ** GetBucketInventoryConfiguration
    getBucketInventoryConfiguration_expectedBucketOwner,
    getBucketInventoryConfiguration_bucket,
    getBucketInventoryConfiguration_id,
    getBucketInventoryConfigurationResponse_inventoryConfiguration,
    getBucketInventoryConfigurationResponse_httpStatus,

    -- ** GetBucketLifecycleConfiguration
    getBucketLifecycleConfiguration_expectedBucketOwner,
    getBucketLifecycleConfiguration_bucket,
    getBucketLifecycleConfigurationResponse_rules,
    getBucketLifecycleConfigurationResponse_httpStatus,

    -- ** GetBucketLocation
    getBucketLocation_expectedBucketOwner,
    getBucketLocation_bucket,
    getBucketLocationResponse_httpStatus,
    getBucketLocationResponse_locationConstraint,

    -- ** GetBucketLogging
    getBucketLogging_expectedBucketOwner,
    getBucketLogging_bucket,
    getBucketLoggingResponse_loggingEnabled,
    getBucketLoggingResponse_httpStatus,

    -- ** GetBucketMetricsConfiguration
    getBucketMetricsConfiguration_expectedBucketOwner,
    getBucketMetricsConfiguration_bucket,
    getBucketMetricsConfiguration_id,
    getBucketMetricsConfigurationResponse_metricsConfiguration,
    getBucketMetricsConfigurationResponse_httpStatus,

    -- ** GetBucketNotificationConfiguration
    getBucketNotificationConfiguration_expectedBucketOwner,
    getBucketNotificationConfiguration_bucket,
    notificationConfiguration_eventBridgeConfiguration,
    notificationConfiguration_lambdaFunctionConfigurations,
    notificationConfiguration_queueConfigurations,
    notificationConfiguration_topicConfigurations,

    -- ** GetBucketOwnershipControls
    getBucketOwnershipControls_expectedBucketOwner,
    getBucketOwnershipControls_bucket,
    getBucketOwnershipControlsResponse_ownershipControls,
    getBucketOwnershipControlsResponse_httpStatus,

    -- ** GetBucketPolicy
    getBucketPolicy_expectedBucketOwner,
    getBucketPolicy_bucket,
    getBucketPolicyResponse_httpStatus,
    getBucketPolicyResponse_policy,

    -- ** GetBucketPolicyStatus
    getBucketPolicyStatus_expectedBucketOwner,
    getBucketPolicyStatus_bucket,
    getBucketPolicyStatusResponse_policyStatus,
    getBucketPolicyStatusResponse_httpStatus,

    -- ** GetBucketReplication
    getBucketReplication_expectedBucketOwner,
    getBucketReplication_bucket,
    getBucketReplicationResponse_replicationConfiguration,
    getBucketReplicationResponse_httpStatus,

    -- ** GetBucketRequestPayment
    getBucketRequestPayment_expectedBucketOwner,
    getBucketRequestPayment_bucket,
    getBucketRequestPaymentResponse_payer,
    getBucketRequestPaymentResponse_httpStatus,

    -- ** GetBucketTagging
    getBucketTagging_expectedBucketOwner,
    getBucketTagging_bucket,
    getBucketTaggingResponse_httpStatus,
    getBucketTaggingResponse_tagSet,

    -- ** GetBucketVersioning
    getBucketVersioning_expectedBucketOwner,
    getBucketVersioning_bucket,
    getBucketVersioningResponse_mfaDelete,
    getBucketVersioningResponse_status,
    getBucketVersioningResponse_httpStatus,

    -- ** GetBucketWebsite
    getBucketWebsite_expectedBucketOwner,
    getBucketWebsite_bucket,
    getBucketWebsiteResponse_errorDocument,
    getBucketWebsiteResponse_indexDocument,
    getBucketWebsiteResponse_redirectAllRequestsTo,
    getBucketWebsiteResponse_routingRules,
    getBucketWebsiteResponse_httpStatus,

    -- ** GetObject
    getObject_checksumMode,
    getObject_expectedBucketOwner,
    getObject_ifMatch,
    getObject_ifModifiedSince,
    getObject_ifNoneMatch,
    getObject_ifUnmodifiedSince,
    getObject_partNumber,
    getObject_range,
    getObject_requestPayer,
    getObject_responseCacheControl,
    getObject_responseContentDisposition,
    getObject_responseContentEncoding,
    getObject_responseContentLanguage,
    getObject_responseContentType,
    getObject_responseExpires,
    getObject_sSECustomerAlgorithm,
    getObject_sSECustomerKey,
    getObject_sSECustomerKeyMD5,
    getObject_versionId,
    getObject_bucket,
    getObject_key,
    getObjectResponse_acceptRanges,
    getObjectResponse_bucketKeyEnabled,
    getObjectResponse_cacheControl,
    getObjectResponse_checksumCRC32,
    getObjectResponse_checksumCRC32C,
    getObjectResponse_checksumSHA1,
    getObjectResponse_checksumSHA256,
    getObjectResponse_contentDisposition,
    getObjectResponse_contentEncoding,
    getObjectResponse_contentLanguage,
    getObjectResponse_contentLength,
    getObjectResponse_contentRange,
    getObjectResponse_contentType,
    getObjectResponse_deleteMarker,
    getObjectResponse_eTag,
    getObjectResponse_expiration,
    getObjectResponse_expires,
    getObjectResponse_lastModified,
    getObjectResponse_metadata,
    getObjectResponse_missingMeta,
    getObjectResponse_objectLockLegalHoldStatus,
    getObjectResponse_objectLockMode,
    getObjectResponse_objectLockRetainUntilDate,
    getObjectResponse_partsCount,
    getObjectResponse_replicationStatus,
    getObjectResponse_requestCharged,
    getObjectResponse_restore,
    getObjectResponse_sSECustomerAlgorithm,
    getObjectResponse_sSECustomerKeyMD5,
    getObjectResponse_sSEKMSKeyId,
    getObjectResponse_serverSideEncryption,
    getObjectResponse_storageClass,
    getObjectResponse_tagCount,
    getObjectResponse_versionId,
    getObjectResponse_websiteRedirectLocation,
    getObjectResponse_httpStatus,
    getObjectResponse_body,

    -- ** GetObjectAcl
    getObjectAcl_expectedBucketOwner,
    getObjectAcl_requestPayer,
    getObjectAcl_versionId,
    getObjectAcl_bucket,
    getObjectAcl_key,
    getObjectAclResponse_grants,
    getObjectAclResponse_owner,
    getObjectAclResponse_requestCharged,
    getObjectAclResponse_httpStatus,

    -- ** GetObjectAttributes
    getObjectAttributes_expectedBucketOwner,
    getObjectAttributes_maxParts,
    getObjectAttributes_partNumberMarker,
    getObjectAttributes_requestPayer,
    getObjectAttributes_sSECustomerAlgorithm,
    getObjectAttributes_sSECustomerKey,
    getObjectAttributes_sSECustomerKeyMD5,
    getObjectAttributes_versionId,
    getObjectAttributes_bucket,
    getObjectAttributes_key,
    getObjectAttributes_objectAttributes,
    getObjectAttributesResponse_checksum,
    getObjectAttributesResponse_deleteMarker,
    getObjectAttributesResponse_eTag,
    getObjectAttributesResponse_lastModified,
    getObjectAttributesResponse_objectParts,
    getObjectAttributesResponse_objectSize,
    getObjectAttributesResponse_requestCharged,
    getObjectAttributesResponse_storageClass,
    getObjectAttributesResponse_versionId,
    getObjectAttributesResponse_httpStatus,

    -- ** GetObjectLegalHold
    getObjectLegalHold_expectedBucketOwner,
    getObjectLegalHold_requestPayer,
    getObjectLegalHold_versionId,
    getObjectLegalHold_bucket,
    getObjectLegalHold_key,
    getObjectLegalHoldResponse_legalHold,
    getObjectLegalHoldResponse_httpStatus,

    -- ** GetObjectLockConfiguration
    getObjectLockConfiguration_expectedBucketOwner,
    getObjectLockConfiguration_bucket,
    getObjectLockConfigurationResponse_objectLockConfiguration,
    getObjectLockConfigurationResponse_httpStatus,

    -- ** GetObjectRetention
    getObjectRetention_expectedBucketOwner,
    getObjectRetention_requestPayer,
    getObjectRetention_versionId,
    getObjectRetention_bucket,
    getObjectRetention_key,
    getObjectRetentionResponse_retention,
    getObjectRetentionResponse_httpStatus,

    -- ** GetObjectTagging
    getObjectTagging_expectedBucketOwner,
    getObjectTagging_requestPayer,
    getObjectTagging_versionId,
    getObjectTagging_bucket,
    getObjectTagging_key,
    getObjectTaggingResponse_versionId,
    getObjectTaggingResponse_httpStatus,
    getObjectTaggingResponse_tagSet,

    -- ** GetObjectTorrent
    getObjectTorrent_expectedBucketOwner,
    getObjectTorrent_requestPayer,
    getObjectTorrent_bucket,
    getObjectTorrent_key,
    getObjectTorrentResponse_requestCharged,
    getObjectTorrentResponse_httpStatus,
    getObjectTorrentResponse_body,

    -- ** GetPublicAccessBlock
    getPublicAccessBlock_expectedBucketOwner,
    getPublicAccessBlock_bucket,
    getPublicAccessBlockResponse_publicAccessBlockConfiguration,
    getPublicAccessBlockResponse_httpStatus,

    -- ** HeadBucket
    headBucket_expectedBucketOwner,
    headBucket_bucket,

    -- ** HeadObject
    headObject_checksumMode,
    headObject_expectedBucketOwner,
    headObject_ifMatch,
    headObject_ifModifiedSince,
    headObject_ifNoneMatch,
    headObject_ifUnmodifiedSince,
    headObject_partNumber,
    headObject_range,
    headObject_requestPayer,
    headObject_sSECustomerAlgorithm,
    headObject_sSECustomerKey,
    headObject_sSECustomerKeyMD5,
    headObject_versionId,
    headObject_bucket,
    headObject_key,
    headObjectResponse_acceptRanges,
    headObjectResponse_archiveStatus,
    headObjectResponse_bucketKeyEnabled,
    headObjectResponse_cacheControl,
    headObjectResponse_checksumCRC32,
    headObjectResponse_checksumCRC32C,
    headObjectResponse_checksumSHA1,
    headObjectResponse_checksumSHA256,
    headObjectResponse_contentDisposition,
    headObjectResponse_contentEncoding,
    headObjectResponse_contentLanguage,
    headObjectResponse_contentLength,
    headObjectResponse_contentType,
    headObjectResponse_deleteMarker,
    headObjectResponse_eTag,
    headObjectResponse_expiration,
    headObjectResponse_expires,
    headObjectResponse_lastModified,
    headObjectResponse_metadata,
    headObjectResponse_missingMeta,
    headObjectResponse_objectLockLegalHoldStatus,
    headObjectResponse_objectLockMode,
    headObjectResponse_objectLockRetainUntilDate,
    headObjectResponse_partsCount,
    headObjectResponse_replicationStatus,
    headObjectResponse_requestCharged,
    headObjectResponse_restore,
    headObjectResponse_sSECustomerAlgorithm,
    headObjectResponse_sSECustomerKeyMD5,
    headObjectResponse_sSEKMSKeyId,
    headObjectResponse_serverSideEncryption,
    headObjectResponse_storageClass,
    headObjectResponse_versionId,
    headObjectResponse_websiteRedirectLocation,
    headObjectResponse_httpStatus,

    -- ** ListBucketAnalyticsConfigurations
    listBucketAnalyticsConfigurations_continuationToken,
    listBucketAnalyticsConfigurations_expectedBucketOwner,
    listBucketAnalyticsConfigurations_bucket,
    listBucketAnalyticsConfigurationsResponse_analyticsConfigurationList,
    listBucketAnalyticsConfigurationsResponse_continuationToken,
    listBucketAnalyticsConfigurationsResponse_isTruncated,
    listBucketAnalyticsConfigurationsResponse_nextContinuationToken,
    listBucketAnalyticsConfigurationsResponse_httpStatus,

    -- ** ListBucketIntelligentTieringConfigurations
    listBucketIntelligentTieringConfigurations_continuationToken,
    listBucketIntelligentTieringConfigurations_bucket,
    listBucketIntelligentTieringConfigurationsResponse_continuationToken,
    listBucketIntelligentTieringConfigurationsResponse_intelligentTieringConfigurationList,
    listBucketIntelligentTieringConfigurationsResponse_isTruncated,
    listBucketIntelligentTieringConfigurationsResponse_nextContinuationToken,
    listBucketIntelligentTieringConfigurationsResponse_httpStatus,

    -- ** ListBucketInventoryConfigurations
    listBucketInventoryConfigurations_continuationToken,
    listBucketInventoryConfigurations_expectedBucketOwner,
    listBucketInventoryConfigurations_bucket,
    listBucketInventoryConfigurationsResponse_continuationToken,
    listBucketInventoryConfigurationsResponse_inventoryConfigurationList,
    listBucketInventoryConfigurationsResponse_isTruncated,
    listBucketInventoryConfigurationsResponse_nextContinuationToken,
    listBucketInventoryConfigurationsResponse_httpStatus,

    -- ** ListBucketMetricsConfigurations
    listBucketMetricsConfigurations_continuationToken,
    listBucketMetricsConfigurations_expectedBucketOwner,
    listBucketMetricsConfigurations_bucket,
    listBucketMetricsConfigurationsResponse_continuationToken,
    listBucketMetricsConfigurationsResponse_isTruncated,
    listBucketMetricsConfigurationsResponse_metricsConfigurationList,
    listBucketMetricsConfigurationsResponse_nextContinuationToken,
    listBucketMetricsConfigurationsResponse_httpStatus,

    -- ** ListBuckets
    listBucketsResponse_buckets,
    listBucketsResponse_owner,
    listBucketsResponse_httpStatus,

    -- ** ListMultipartUploads
    listMultipartUploads_delimiter,
    listMultipartUploads_encodingType,
    listMultipartUploads_expectedBucketOwner,
    listMultipartUploads_keyMarker,
    listMultipartUploads_maxUploads,
    listMultipartUploads_prefix,
    listMultipartUploads_uploadIdMarker,
    listMultipartUploads_bucket,
    listMultipartUploadsResponse_bucket,
    listMultipartUploadsResponse_commonPrefixes,
    listMultipartUploadsResponse_delimiter,
    listMultipartUploadsResponse_encodingType,
    listMultipartUploadsResponse_isTruncated,
    listMultipartUploadsResponse_keyMarker,
    listMultipartUploadsResponse_maxUploads,
    listMultipartUploadsResponse_nextKeyMarker,
    listMultipartUploadsResponse_nextUploadIdMarker,
    listMultipartUploadsResponse_prefix,
    listMultipartUploadsResponse_uploadIdMarker,
    listMultipartUploadsResponse_uploads,
    listMultipartUploadsResponse_httpStatus,

    -- ** ListObjectVersions
    listObjectVersions_delimiter,
    listObjectVersions_encodingType,
    listObjectVersions_expectedBucketOwner,
    listObjectVersions_keyMarker,
    listObjectVersions_maxKeys,
    listObjectVersions_prefix,
    listObjectVersions_versionIdMarker,
    listObjectVersions_bucket,
    listObjectVersionsResponse_commonPrefixes,
    listObjectVersionsResponse_deleteMarkers,
    listObjectVersionsResponse_delimiter,
    listObjectVersionsResponse_encodingType,
    listObjectVersionsResponse_isTruncated,
    listObjectVersionsResponse_keyMarker,
    listObjectVersionsResponse_maxKeys,
    listObjectVersionsResponse_name,
    listObjectVersionsResponse_nextKeyMarker,
    listObjectVersionsResponse_nextVersionIdMarker,
    listObjectVersionsResponse_prefix,
    listObjectVersionsResponse_versionIdMarker,
    listObjectVersionsResponse_versions,
    listObjectVersionsResponse_httpStatus,

    -- ** ListObjects
    listObjects_delimiter,
    listObjects_encodingType,
    listObjects_expectedBucketOwner,
    listObjects_marker,
    listObjects_maxKeys,
    listObjects_prefix,
    listObjects_requestPayer,
    listObjects_bucket,
    listObjectsResponse_commonPrefixes,
    listObjectsResponse_contents,
    listObjectsResponse_delimiter,
    listObjectsResponse_encodingType,
    listObjectsResponse_isTruncated,
    listObjectsResponse_marker,
    listObjectsResponse_maxKeys,
    listObjectsResponse_name,
    listObjectsResponse_nextMarker,
    listObjectsResponse_prefix,
    listObjectsResponse_httpStatus,

    -- ** ListObjectsV2
    listObjectsV2_continuationToken,
    listObjectsV2_delimiter,
    listObjectsV2_encodingType,
    listObjectsV2_expectedBucketOwner,
    listObjectsV2_fetchOwner,
    listObjectsV2_maxKeys,
    listObjectsV2_prefix,
    listObjectsV2_requestPayer,
    listObjectsV2_startAfter,
    listObjectsV2_bucket,
    listObjectsV2Response_commonPrefixes,
    listObjectsV2Response_contents,
    listObjectsV2Response_continuationToken,
    listObjectsV2Response_delimiter,
    listObjectsV2Response_encodingType,
    listObjectsV2Response_isTruncated,
    listObjectsV2Response_keyCount,
    listObjectsV2Response_maxKeys,
    listObjectsV2Response_name,
    listObjectsV2Response_nextContinuationToken,
    listObjectsV2Response_prefix,
    listObjectsV2Response_startAfter,
    listObjectsV2Response_httpStatus,

    -- ** ListParts
    listParts_expectedBucketOwner,
    listParts_maxParts,
    listParts_partNumberMarker,
    listParts_requestPayer,
    listParts_sSECustomerAlgorithm,
    listParts_sSECustomerKey,
    listParts_sSECustomerKeyMD5,
    listParts_bucket,
    listParts_key,
    listParts_uploadId,
    listPartsResponse_abortDate,
    listPartsResponse_abortRuleId,
    listPartsResponse_bucket,
    listPartsResponse_checksumAlgorithm,
    listPartsResponse_initiator,
    listPartsResponse_isTruncated,
    listPartsResponse_key,
    listPartsResponse_maxParts,
    listPartsResponse_nextPartNumberMarker,
    listPartsResponse_owner,
    listPartsResponse_partNumberMarker,
    listPartsResponse_parts,
    listPartsResponse_requestCharged,
    listPartsResponse_storageClass,
    listPartsResponse_uploadId,
    listPartsResponse_httpStatus,

    -- ** PutBucketAccelerateConfiguration
    putBucketAccelerateConfiguration_checksumAlgorithm,
    putBucketAccelerateConfiguration_expectedBucketOwner,
    putBucketAccelerateConfiguration_bucket,
    putBucketAccelerateConfiguration_accelerateConfiguration,

    -- ** PutBucketAcl
    putBucketAcl_acl,
    putBucketAcl_accessControlPolicy,
    putBucketAcl_checksumAlgorithm,
    putBucketAcl_contentMD5,
    putBucketAcl_expectedBucketOwner,
    putBucketAcl_grantFullControl,
    putBucketAcl_grantRead,
    putBucketAcl_grantReadACP,
    putBucketAcl_grantWrite,
    putBucketAcl_grantWriteACP,
    putBucketAcl_bucket,

    -- ** PutBucketAnalyticsConfiguration
    putBucketAnalyticsConfiguration_expectedBucketOwner,
    putBucketAnalyticsConfiguration_bucket,
    putBucketAnalyticsConfiguration_id,
    putBucketAnalyticsConfiguration_analyticsConfiguration,

    -- ** PutBucketCors
    putBucketCors_checksumAlgorithm,
    putBucketCors_contentMD5,
    putBucketCors_expectedBucketOwner,
    putBucketCors_bucket,
    putBucketCors_cORSConfiguration,

    -- ** PutBucketEncryption
    putBucketEncryption_checksumAlgorithm,
    putBucketEncryption_contentMD5,
    putBucketEncryption_expectedBucketOwner,
    putBucketEncryption_bucket,
    putBucketEncryption_serverSideEncryptionConfiguration,

    -- ** PutBucketIntelligentTieringConfiguration
    putBucketIntelligentTieringConfiguration_bucket,
    putBucketIntelligentTieringConfiguration_id,
    putBucketIntelligentTieringConfiguration_intelligentTieringConfiguration,

    -- ** PutBucketInventoryConfiguration
    putBucketInventoryConfiguration_expectedBucketOwner,
    putBucketInventoryConfiguration_bucket,
    putBucketInventoryConfiguration_id,
    putBucketInventoryConfiguration_inventoryConfiguration,

    -- ** PutBucketLifecycleConfiguration
    putBucketLifecycleConfiguration_checksumAlgorithm,
    putBucketLifecycleConfiguration_expectedBucketOwner,
    putBucketLifecycleConfiguration_lifecycleConfiguration,
    putBucketLifecycleConfiguration_bucket,

    -- ** PutBucketLogging
    putBucketLogging_checksumAlgorithm,
    putBucketLogging_contentMD5,
    putBucketLogging_expectedBucketOwner,
    putBucketLogging_bucket,
    putBucketLogging_bucketLoggingStatus,

    -- ** PutBucketMetricsConfiguration
    putBucketMetricsConfiguration_expectedBucketOwner,
    putBucketMetricsConfiguration_bucket,
    putBucketMetricsConfiguration_id,
    putBucketMetricsConfiguration_metricsConfiguration,

    -- ** PutBucketNotificationConfiguration
    putBucketNotificationConfiguration_expectedBucketOwner,
    putBucketNotificationConfiguration_skipDestinationValidation,
    putBucketNotificationConfiguration_bucket,
    putBucketNotificationConfiguration_notificationConfiguration,

    -- ** PutBucketOwnershipControls
    putBucketOwnershipControls_contentMD5,
    putBucketOwnershipControls_expectedBucketOwner,
    putBucketOwnershipControls_bucket,
    putBucketOwnershipControls_ownershipControls,

    -- ** PutBucketPolicy
    putBucketPolicy_checksumAlgorithm,
    putBucketPolicy_confirmRemoveSelfBucketAccess,
    putBucketPolicy_contentMD5,
    putBucketPolicy_expectedBucketOwner,
    putBucketPolicy_bucket,
    putBucketPolicy_policy,

    -- ** PutBucketReplication
    putBucketReplication_checksumAlgorithm,
    putBucketReplication_contentMD5,
    putBucketReplication_expectedBucketOwner,
    putBucketReplication_token,
    putBucketReplication_bucket,
    putBucketReplication_replicationConfiguration,

    -- ** PutBucketRequestPayment
    putBucketRequestPayment_checksumAlgorithm,
    putBucketRequestPayment_contentMD5,
    putBucketRequestPayment_expectedBucketOwner,
    putBucketRequestPayment_bucket,
    putBucketRequestPayment_requestPaymentConfiguration,

    -- ** PutBucketTagging
    putBucketTagging_checksumAlgorithm,
    putBucketTagging_contentMD5,
    putBucketTagging_expectedBucketOwner,
    putBucketTagging_bucket,
    putBucketTagging_tagging,

    -- ** PutBucketVersioning
    putBucketVersioning_checksumAlgorithm,
    putBucketVersioning_contentMD5,
    putBucketVersioning_expectedBucketOwner,
    putBucketVersioning_mfa,
    putBucketVersioning_bucket,
    putBucketVersioning_versioningConfiguration,

    -- ** PutBucketWebsite
    putBucketWebsite_checksumAlgorithm,
    putBucketWebsite_contentMD5,
    putBucketWebsite_expectedBucketOwner,
    putBucketWebsite_bucket,
    putBucketWebsite_websiteConfiguration,

    -- ** PutObject
    putObject_acl,
    putObject_bucketKeyEnabled,
    putObject_cacheControl,
    putObject_checksumAlgorithm,
    putObject_checksumCRC32,
    putObject_checksumCRC32C,
    putObject_checksumSHA1,
    putObject_checksumSHA256,
    putObject_contentDisposition,
    putObject_contentEncoding,
    putObject_contentLanguage,
    putObject_contentLength,
    putObject_contentMD5,
    putObject_contentType,
    putObject_expectedBucketOwner,
    putObject_expires,
    putObject_grantFullControl,
    putObject_grantRead,
    putObject_grantReadACP,
    putObject_grantWriteACP,
    putObject_metadata,
    putObject_objectLockLegalHoldStatus,
    putObject_objectLockMode,
    putObject_objectLockRetainUntilDate,
    putObject_requestPayer,
    putObject_sSECustomerAlgorithm,
    putObject_sSECustomerKey,
    putObject_sSECustomerKeyMD5,
    putObject_sSEKMSEncryptionContext,
    putObject_sSEKMSKeyId,
    putObject_serverSideEncryption,
    putObject_storageClass,
    putObject_tagging,
    putObject_websiteRedirectLocation,
    putObject_bucket,
    putObject_key,
    putObject_body,
    putObjectResponse_bucketKeyEnabled,
    putObjectResponse_checksumCRC32,
    putObjectResponse_checksumCRC32C,
    putObjectResponse_checksumSHA1,
    putObjectResponse_checksumSHA256,
    putObjectResponse_eTag,
    putObjectResponse_expiration,
    putObjectResponse_requestCharged,
    putObjectResponse_sSECustomerAlgorithm,
    putObjectResponse_sSECustomerKeyMD5,
    putObjectResponse_sSEKMSEncryptionContext,
    putObjectResponse_sSEKMSKeyId,
    putObjectResponse_serverSideEncryption,
    putObjectResponse_versionId,
    putObjectResponse_httpStatus,

    -- ** PutObjectAcl
    putObjectAcl_acl,
    putObjectAcl_accessControlPolicy,
    putObjectAcl_checksumAlgorithm,
    putObjectAcl_contentMD5,
    putObjectAcl_expectedBucketOwner,
    putObjectAcl_grantFullControl,
    putObjectAcl_grantRead,
    putObjectAcl_grantReadACP,
    putObjectAcl_grantWrite,
    putObjectAcl_grantWriteACP,
    putObjectAcl_requestPayer,
    putObjectAcl_versionId,
    putObjectAcl_bucket,
    putObjectAcl_key,
    putObjectAclResponse_requestCharged,
    putObjectAclResponse_httpStatus,

    -- ** PutObjectLegalHold
    putObjectLegalHold_checksumAlgorithm,
    putObjectLegalHold_contentMD5,
    putObjectLegalHold_expectedBucketOwner,
    putObjectLegalHold_legalHold,
    putObjectLegalHold_requestPayer,
    putObjectLegalHold_versionId,
    putObjectLegalHold_bucket,
    putObjectLegalHold_key,
    putObjectLegalHoldResponse_requestCharged,
    putObjectLegalHoldResponse_httpStatus,

    -- ** PutObjectLockConfiguration
    putObjectLockConfiguration_checksumAlgorithm,
    putObjectLockConfiguration_contentMD5,
    putObjectLockConfiguration_expectedBucketOwner,
    putObjectLockConfiguration_objectLockConfiguration,
    putObjectLockConfiguration_requestPayer,
    putObjectLockConfiguration_token,
    putObjectLockConfiguration_bucket,
    putObjectLockConfigurationResponse_requestCharged,
    putObjectLockConfigurationResponse_httpStatus,

    -- ** PutObjectRetention
    putObjectRetention_bypassGovernanceRetention,
    putObjectRetention_checksumAlgorithm,
    putObjectRetention_contentMD5,
    putObjectRetention_expectedBucketOwner,
    putObjectRetention_requestPayer,
    putObjectRetention_retention,
    putObjectRetention_versionId,
    putObjectRetention_bucket,
    putObjectRetention_key,
    putObjectRetentionResponse_requestCharged,
    putObjectRetentionResponse_httpStatus,

    -- ** PutObjectTagging
    putObjectTagging_checksumAlgorithm,
    putObjectTagging_contentMD5,
    putObjectTagging_expectedBucketOwner,
    putObjectTagging_requestPayer,
    putObjectTagging_versionId,
    putObjectTagging_bucket,
    putObjectTagging_key,
    putObjectTagging_tagging,
    putObjectTaggingResponse_versionId,
    putObjectTaggingResponse_httpStatus,

    -- ** PutPublicAccessBlock
    putPublicAccessBlock_checksumAlgorithm,
    putPublicAccessBlock_contentMD5,
    putPublicAccessBlock_expectedBucketOwner,
    putPublicAccessBlock_bucket,
    putPublicAccessBlock_publicAccessBlockConfiguration,

    -- ** RestoreObject
    restoreObject_checksumAlgorithm,
    restoreObject_expectedBucketOwner,
    restoreObject_requestPayer,
    restoreObject_restoreRequest,
    restoreObject_versionId,
    restoreObject_bucket,
    restoreObject_key,
    restoreObjectResponse_requestCharged,
    restoreObjectResponse_restoreOutputPath,
    restoreObjectResponse_httpStatus,

    -- ** SelectObjectContent
    selectObjectContent_expectedBucketOwner,
    selectObjectContent_requestProgress,
    selectObjectContent_sSECustomerAlgorithm,
    selectObjectContent_sSECustomerKey,
    selectObjectContent_sSECustomerKeyMD5,
    selectObjectContent_scanRange,
    selectObjectContent_bucket,
    selectObjectContent_key,
    selectObjectContent_expression,
    selectObjectContent_expressionType,
    selectObjectContent_inputSerialization,
    selectObjectContent_outputSerialization,
    selectObjectContentResponse_payload,
    selectObjectContentResponse_httpStatus,

    -- ** UploadPart
    uploadPart_checksumAlgorithm,
    uploadPart_checksumCRC32,
    uploadPart_checksumCRC32C,
    uploadPart_checksumSHA1,
    uploadPart_checksumSHA256,
    uploadPart_contentLength,
    uploadPart_contentMD5,
    uploadPart_expectedBucketOwner,
    uploadPart_requestPayer,
    uploadPart_sSECustomerAlgorithm,
    uploadPart_sSECustomerKey,
    uploadPart_sSECustomerKeyMD5,
    uploadPart_bucket,
    uploadPart_key,
    uploadPart_partNumber,
    uploadPart_uploadId,
    uploadPart_body,
    uploadPartResponse_bucketKeyEnabled,
    uploadPartResponse_checksumCRC32,
    uploadPartResponse_checksumCRC32C,
    uploadPartResponse_checksumSHA1,
    uploadPartResponse_checksumSHA256,
    uploadPartResponse_eTag,
    uploadPartResponse_requestCharged,
    uploadPartResponse_sSECustomerAlgorithm,
    uploadPartResponse_sSECustomerKeyMD5,
    uploadPartResponse_sSEKMSKeyId,
    uploadPartResponse_serverSideEncryption,
    uploadPartResponse_httpStatus,

    -- ** UploadPartCopy
    uploadPartCopy_copySourceIfMatch,
    uploadPartCopy_copySourceIfModifiedSince,
    uploadPartCopy_copySourceIfNoneMatch,
    uploadPartCopy_copySourceIfUnmodifiedSince,
    uploadPartCopy_copySourceRange,
    uploadPartCopy_copySourceSSECustomerAlgorithm,
    uploadPartCopy_copySourceSSECustomerKey,
    uploadPartCopy_copySourceSSECustomerKeyMD5,
    uploadPartCopy_expectedBucketOwner,
    uploadPartCopy_expectedSourceBucketOwner,
    uploadPartCopy_requestPayer,
    uploadPartCopy_sSECustomerAlgorithm,
    uploadPartCopy_sSECustomerKey,
    uploadPartCopy_sSECustomerKeyMD5,
    uploadPartCopy_bucket,
    uploadPartCopy_copySource,
    uploadPartCopy_key,
    uploadPartCopy_partNumber,
    uploadPartCopy_uploadId,
    uploadPartCopyResponse_bucketKeyEnabled,
    uploadPartCopyResponse_copyPartResult,
    uploadPartCopyResponse_copySourceVersionId,
    uploadPartCopyResponse_requestCharged,
    uploadPartCopyResponse_sSECustomerAlgorithm,
    uploadPartCopyResponse_sSECustomerKeyMD5,
    uploadPartCopyResponse_sSEKMSKeyId,
    uploadPartCopyResponse_serverSideEncryption,
    uploadPartCopyResponse_httpStatus,

    -- ** WriteGetObjectResponse
    writeGetObjectResponse_acceptRanges,
    writeGetObjectResponse_bucketKeyEnabled,
    writeGetObjectResponse_cacheControl,
    writeGetObjectResponse_checksumCRC32,
    writeGetObjectResponse_checksumCRC32C,
    writeGetObjectResponse_checksumSHA1,
    writeGetObjectResponse_checksumSHA256,
    writeGetObjectResponse_contentDisposition,
    writeGetObjectResponse_contentEncoding,
    writeGetObjectResponse_contentLanguage,
    writeGetObjectResponse_contentLength,
    writeGetObjectResponse_contentRange,
    writeGetObjectResponse_contentType,
    writeGetObjectResponse_deleteMarker,
    writeGetObjectResponse_eTag,
    writeGetObjectResponse_errorCode,
    writeGetObjectResponse_errorMessage,
    writeGetObjectResponse_expiration,
    writeGetObjectResponse_expires,
    writeGetObjectResponse_lastModified,
    writeGetObjectResponse_metadata,
    writeGetObjectResponse_missingMeta,
    writeGetObjectResponse_objectLockLegalHoldStatus,
    writeGetObjectResponse_objectLockMode,
    writeGetObjectResponse_objectLockRetainUntilDate,
    writeGetObjectResponse_partsCount,
    writeGetObjectResponse_replicationStatus,
    writeGetObjectResponse_requestCharged,
    writeGetObjectResponse_restore,
    writeGetObjectResponse_sSECustomerAlgorithm,
    writeGetObjectResponse_sSECustomerKeyMD5,
    writeGetObjectResponse_sSEKMSKeyId,
    writeGetObjectResponse_serverSideEncryption,
    writeGetObjectResponse_statusCode,
    writeGetObjectResponse_storageClass,
    writeGetObjectResponse_tagCount,
    writeGetObjectResponse_versionId,
    writeGetObjectResponse_requestRoute,
    writeGetObjectResponse_requestToken,
    writeGetObjectResponse_body,

    -- * Types

    -- ** AbortIncompleteMultipartUpload
    abortIncompleteMultipartUpload_daysAfterInitiation,

    -- ** AccelerateConfiguration
    accelerateConfiguration_status,

    -- ** AccessControlPolicy
    accessControlPolicy_grants,
    accessControlPolicy_owner,

    -- ** AccessControlTranslation
    accessControlTranslation_owner,

    -- ** AnalyticsAndOperator
    analyticsAndOperator_prefix,
    analyticsAndOperator_tags,

    -- ** AnalyticsConfiguration
    analyticsConfiguration_filter,
    analyticsConfiguration_id,
    analyticsConfiguration_storageClassAnalysis,

    -- ** AnalyticsExportDestination
    analyticsExportDestination_s3BucketDestination,

    -- ** AnalyticsFilter
    analyticsFilter_and,
    analyticsFilter_prefix,
    analyticsFilter_tag,

    -- ** AnalyticsS3BucketDestination
    analyticsS3BucketDestination_bucketAccountId,
    analyticsS3BucketDestination_prefix,
    analyticsS3BucketDestination_format,
    analyticsS3BucketDestination_bucket,

    -- ** Bucket
    bucket_creationDate,
    bucket_name,

    -- ** BucketLifecycleConfiguration
    bucketLifecycleConfiguration_rules,

    -- ** BucketLoggingStatus
    bucketLoggingStatus_loggingEnabled,

    -- ** CORSConfiguration
    cORSConfiguration_cORSRules,

    -- ** CORSRule
    cORSRule_allowedHeaders,
    cORSRule_exposeHeaders,
    cORSRule_id,
    cORSRule_maxAgeSeconds,
    cORSRule_allowedMethods,
    cORSRule_allowedOrigins,

    -- ** CSVInput
    cSVInput_allowQuotedRecordDelimiter,
    cSVInput_comments,
    cSVInput_fieldDelimiter,
    cSVInput_fileHeaderInfo,
    cSVInput_quoteCharacter,
    cSVInput_quoteEscapeCharacter,
    cSVInput_recordDelimiter,

    -- ** CSVOutput
    cSVOutput_fieldDelimiter,
    cSVOutput_quoteCharacter,
    cSVOutput_quoteEscapeCharacter,
    cSVOutput_quoteFields,
    cSVOutput_recordDelimiter,

    -- ** Checksum
    checksum_checksumCRC32,
    checksum_checksumCRC32C,
    checksum_checksumSHA1,
    checksum_checksumSHA256,

    -- ** CommonPrefix
    commonPrefix_prefix,

    -- ** CompletedMultipartUpload
    completedMultipartUpload_parts,

    -- ** CompletedPart
    completedPart_checksumCRC32,
    completedPart_checksumCRC32C,
    completedPart_checksumSHA1,
    completedPart_checksumSHA256,
    completedPart_partNumber,
    completedPart_eTag,

    -- ** Condition
    condition_httpErrorCodeReturnedEquals,
    condition_keyPrefixEquals,

    -- ** ContinuationEvent

    -- ** CopyObjectResult
    copyObjectResult_checksumCRC32,
    copyObjectResult_checksumCRC32C,
    copyObjectResult_checksumSHA1,
    copyObjectResult_checksumSHA256,
    copyObjectResult_eTag,
    copyObjectResult_lastModified,

    -- ** CopyPartResult
    copyPartResult_checksumCRC32,
    copyPartResult_checksumCRC32C,
    copyPartResult_checksumSHA1,
    copyPartResult_checksumSHA256,
    copyPartResult_eTag,
    copyPartResult_lastModified,

    -- ** CreateBucketConfiguration
    createBucketConfiguration_locationConstraint,

    -- ** DefaultRetention
    defaultRetention_days,
    defaultRetention_mode,
    defaultRetention_years,

    -- ** Delete
    delete_quiet,
    delete_objects,

    -- ** DeleteMarkerEntry
    deleteMarkerEntry_isLatest,
    deleteMarkerEntry_key,
    deleteMarkerEntry_lastModified,
    deleteMarkerEntry_owner,
    deleteMarkerEntry_versionId,

    -- ** DeleteMarkerReplication
    deleteMarkerReplication_status,

    -- ** DeletedObject
    deletedObject_deleteMarker,
    deletedObject_deleteMarkerVersionId,
    deletedObject_key,
    deletedObject_versionId,

    -- ** Destination
    destination_accessControlTranslation,
    destination_account,
    destination_encryptionConfiguration,
    destination_metrics,
    destination_replicationTime,
    destination_storageClass,
    destination_bucket,

    -- ** Encryption
    encryption_kmsContext,
    encryption_kmsKeyId,
    encryption_encryptionType,

    -- ** EncryptionConfiguration
    encryptionConfiguration_replicaKmsKeyID,

    -- ** EndEvent

    -- ** ErrorDocument
    errorDocument_key,

    -- ** EventBridgeConfiguration

    -- ** ExistingObjectReplication
    existingObjectReplication_status,

    -- ** FilterRule
    filterRule_name,
    filterRule_value,

    -- ** GetObjectAttributesParts
    getObjectAttributesParts_isTruncated,
    getObjectAttributesParts_maxParts,
    getObjectAttributesParts_nextPartNumberMarker,
    getObjectAttributesParts_partNumberMarker,
    getObjectAttributesParts_parts,
    getObjectAttributesParts_totalPartsCount,

    -- ** GlacierJobParameters
    glacierJobParameters_tier,

    -- ** Grant
    grant_grantee,
    grant_permission,

    -- ** Grantee
    grantee_displayName,
    grantee_emailAddress,
    grantee_id,
    grantee_uri,
    grantee_type,

    -- ** IndexDocument
    indexDocument_suffix,

    -- ** Initiator
    initiator_displayName,
    initiator_id,

    -- ** InputSerialization
    inputSerialization_csv,
    inputSerialization_compressionType,
    inputSerialization_json,
    inputSerialization_parquet,

    -- ** IntelligentTieringAndOperator
    intelligentTieringAndOperator_prefix,
    intelligentTieringAndOperator_tags,

    -- ** IntelligentTieringConfiguration
    intelligentTieringConfiguration_filter,
    intelligentTieringConfiguration_id,
    intelligentTieringConfiguration_status,
    intelligentTieringConfiguration_tierings,

    -- ** IntelligentTieringFilter
    intelligentTieringFilter_and,
    intelligentTieringFilter_prefix,
    intelligentTieringFilter_tag,

    -- ** InventoryConfiguration
    inventoryConfiguration_filter,
    inventoryConfiguration_optionalFields,
    inventoryConfiguration_destination,
    inventoryConfiguration_isEnabled,
    inventoryConfiguration_id,
    inventoryConfiguration_includedObjectVersions,
    inventoryConfiguration_schedule,

    -- ** InventoryDestination
    inventoryDestination_s3BucketDestination,

    -- ** InventoryEncryption
    inventoryEncryption_ssekms,
    inventoryEncryption_sses3,

    -- ** InventoryFilter
    inventoryFilter_prefix,

    -- ** InventoryS3BucketDestination
    inventoryS3BucketDestination_accountId,
    inventoryS3BucketDestination_encryption,
    inventoryS3BucketDestination_prefix,
    inventoryS3BucketDestination_bucket,
    inventoryS3BucketDestination_format,

    -- ** InventorySchedule
    inventorySchedule_frequency,

    -- ** JSONInput
    jSONInput_type,

    -- ** JSONOutput
    jSONOutput_recordDelimiter,

    -- ** LambdaFunctionConfiguration
    lambdaFunctionConfiguration_filter,
    lambdaFunctionConfiguration_id,
    lambdaFunctionConfiguration_lambdaFunctionArn,
    lambdaFunctionConfiguration_events,

    -- ** LifecycleExpiration
    lifecycleExpiration_date,
    lifecycleExpiration_days,
    lifecycleExpiration_expiredObjectDeleteMarker,

    -- ** LifecycleRule
    lifecycleRule_abortIncompleteMultipartUpload,
    lifecycleRule_expiration,
    lifecycleRule_filter,
    lifecycleRule_id,
    lifecycleRule_noncurrentVersionExpiration,
    lifecycleRule_noncurrentVersionTransitions,
    lifecycleRule_prefix,
    lifecycleRule_transitions,
    lifecycleRule_status,

    -- ** LifecycleRuleAndOperator
    lifecycleRuleAndOperator_objectSizeGreaterThan,
    lifecycleRuleAndOperator_objectSizeLessThan,
    lifecycleRuleAndOperator_prefix,
    lifecycleRuleAndOperator_tags,

    -- ** LifecycleRuleFilter
    lifecycleRuleFilter_and,
    lifecycleRuleFilter_objectSizeGreaterThan,
    lifecycleRuleFilter_objectSizeLessThan,
    lifecycleRuleFilter_prefix,
    lifecycleRuleFilter_tag,

    -- ** LoggingEnabled
    loggingEnabled_targetGrants,
    loggingEnabled_targetBucket,
    loggingEnabled_targetPrefix,

    -- ** MetadataEntry
    metadataEntry_name,
    metadataEntry_value,

    -- ** Metrics
    metrics_eventThreshold,
    metrics_status,

    -- ** MetricsAndOperator
    metricsAndOperator_accessPointArn,
    metricsAndOperator_prefix,
    metricsAndOperator_tags,

    -- ** MetricsConfiguration
    metricsConfiguration_filter,
    metricsConfiguration_id,

    -- ** MetricsFilter
    metricsFilter_accessPointArn,
    metricsFilter_and,
    metricsFilter_prefix,
    metricsFilter_tag,

    -- ** MultipartUpload
    multipartUpload_checksumAlgorithm,
    multipartUpload_initiated,
    multipartUpload_initiator,
    multipartUpload_key,
    multipartUpload_owner,
    multipartUpload_storageClass,
    multipartUpload_uploadId,

    -- ** NoncurrentVersionExpiration
    noncurrentVersionExpiration_newerNoncurrentVersions,
    noncurrentVersionExpiration_noncurrentDays,

    -- ** NoncurrentVersionTransition
    noncurrentVersionTransition_newerNoncurrentVersions,
    noncurrentVersionTransition_noncurrentDays,
    noncurrentVersionTransition_storageClass,

    -- ** NotificationConfiguration
    notificationConfiguration_eventBridgeConfiguration,
    notificationConfiguration_lambdaFunctionConfigurations,
    notificationConfiguration_queueConfigurations,
    notificationConfiguration_topicConfigurations,

    -- ** NotificationConfigurationFilter
    notificationConfigurationFilter_key,

    -- ** Object
    object_checksumAlgorithm,
    object_owner,
    object_eTag,
    object_size,
    object_key,
    object_storageClass,
    object_lastModified,

    -- ** ObjectIdentifier
    objectIdentifier_versionId,
    objectIdentifier_key,

    -- ** ObjectLockConfiguration
    objectLockConfiguration_objectLockEnabled,
    objectLockConfiguration_rule,

    -- ** ObjectLockLegalHold
    objectLockLegalHold_status,

    -- ** ObjectLockRetention
    objectLockRetention_mode,
    objectLockRetention_retainUntilDate,

    -- ** ObjectLockRule
    objectLockRule_defaultRetention,

    -- ** ObjectPart
    objectPart_checksumCRC32,
    objectPart_checksumCRC32C,
    objectPart_checksumSHA1,
    objectPart_checksumSHA256,
    objectPart_partNumber,
    objectPart_size,

    -- ** ObjectVersion
    objectVersion_checksumAlgorithm,
    objectVersion_eTag,
    objectVersion_isLatest,
    objectVersion_key,
    objectVersion_lastModified,
    objectVersion_owner,
    objectVersion_size,
    objectVersion_storageClass,
    objectVersion_versionId,

    -- ** OutputLocation
    outputLocation_s3,

    -- ** OutputSerialization
    outputSerialization_csv,
    outputSerialization_json,

    -- ** Owner
    owner_displayName,
    owner_id,

    -- ** OwnershipControls
    ownershipControls_rules,

    -- ** OwnershipControlsRule
    ownershipControlsRule_objectOwnership,

    -- ** ParquetInput

    -- ** Part
    part_checksumCRC32,
    part_checksumCRC32C,
    part_checksumSHA1,
    part_checksumSHA256,
    part_eTag,
    part_lastModified,
    part_partNumber,
    part_size,

    -- ** PolicyStatus
    policyStatus_isPublic,

    -- ** Progress
    progress_bytesProcessed,
    progress_bytesReturned,
    progress_bytesScanned,

    -- ** ProgressEvent
    progressEvent_details,

    -- ** PublicAccessBlockConfiguration
    publicAccessBlockConfiguration_blockPublicAcls,
    publicAccessBlockConfiguration_blockPublicPolicy,
    publicAccessBlockConfiguration_ignorePublicAcls,
    publicAccessBlockConfiguration_restrictPublicBuckets,

    -- ** QueueConfiguration
    queueConfiguration_filter,
    queueConfiguration_id,
    queueConfiguration_queueArn,
    queueConfiguration_events,

    -- ** RecordsEvent
    recordsEvent_payload,

    -- ** Redirect
    redirect_hostName,
    redirect_httpRedirectCode,
    redirect_protocol,
    redirect_replaceKeyPrefixWith,
    redirect_replaceKeyWith,

    -- ** RedirectAllRequestsTo
    redirectAllRequestsTo_protocol,
    redirectAllRequestsTo_hostName,

    -- ** ReplicaModifications
    replicaModifications_status,

    -- ** ReplicationConfiguration
    replicationConfiguration_role,
    replicationConfiguration_rules,

    -- ** ReplicationRule
    replicationRule_deleteMarkerReplication,
    replicationRule_existingObjectReplication,
    replicationRule_filter,
    replicationRule_id,
    replicationRule_prefix,
    replicationRule_priority,
    replicationRule_sourceSelectionCriteria,
    replicationRule_status,
    replicationRule_destination,

    -- ** ReplicationRuleAndOperator
    replicationRuleAndOperator_prefix,
    replicationRuleAndOperator_tags,

    -- ** ReplicationRuleFilter
    replicationRuleFilter_and,
    replicationRuleFilter_prefix,
    replicationRuleFilter_tag,

    -- ** ReplicationTime
    replicationTime_status,
    replicationTime_time,

    -- ** ReplicationTimeValue
    replicationTimeValue_minutes,

    -- ** RequestPaymentConfiguration
    requestPaymentConfiguration_payer,

    -- ** RequestProgress
    requestProgress_enabled,

    -- ** RestoreRequest
    restoreRequest_days,
    restoreRequest_description,
    restoreRequest_glacierJobParameters,
    restoreRequest_outputLocation,
    restoreRequest_selectParameters,
    restoreRequest_tier,
    restoreRequest_type,

    -- ** RoutingRule
    routingRule_condition,
    routingRule_redirect,

    -- ** S3KeyFilter
    s3KeyFilter_filterRules,

    -- ** S3Location
    s3Location_accessControlList,
    s3Location_cannedACL,
    s3Location_encryption,
    s3Location_storageClass,
    s3Location_tagging,
    s3Location_userMetadata,
    s3Location_bucketName,
    s3Location_prefix,

    -- ** S3ServiceError
    s3ServiceError_code,
    s3ServiceError_key,
    s3ServiceError_message,
    s3ServiceError_versionId,

    -- ** SSEKMS
    ssekms_keyId,

    -- ** SSES3

    -- ** ScanRange
    scanRange_end,
    scanRange_start,

    -- ** SelectObjectContentEventStream
    selectObjectContentEventStream_cont,
    selectObjectContentEventStream_end,
    selectObjectContentEventStream_progress,
    selectObjectContentEventStream_records,
    selectObjectContentEventStream_stats,

    -- ** SelectParameters
    selectParameters_inputSerialization,
    selectParameters_expressionType,
    selectParameters_expression,
    selectParameters_outputSerialization,

    -- ** ServerSideEncryptionByDefault
    serverSideEncryptionByDefault_kmsMasterKeyID,
    serverSideEncryptionByDefault_sSEAlgorithm,

    -- ** ServerSideEncryptionConfiguration
    serverSideEncryptionConfiguration_rules,

    -- ** ServerSideEncryptionRule
    serverSideEncryptionRule_applyServerSideEncryptionByDefault,
    serverSideEncryptionRule_bucketKeyEnabled,

    -- ** SourceSelectionCriteria
    sourceSelectionCriteria_replicaModifications,
    sourceSelectionCriteria_sseKmsEncryptedObjects,

    -- ** SseKmsEncryptedObjects
    sseKmsEncryptedObjects_status,

    -- ** Stats
    stats_bytesProcessed,
    stats_bytesReturned,
    stats_bytesScanned,

    -- ** StatsEvent
    statsEvent_details,

    -- ** StorageClassAnalysis
    storageClassAnalysis_dataExport,

    -- ** StorageClassAnalysisDataExport
    storageClassAnalysisDataExport_outputSchemaVersion,
    storageClassAnalysisDataExport_destination,

    -- ** Tag
    tag_key,
    tag_value,

    -- ** Tagging
    tagging_tagSet,

    -- ** TargetGrant
    targetGrant_grantee,
    targetGrant_permission,

    -- ** Tiering
    tiering_days,
    tiering_accessTier,

    -- ** TopicConfiguration
    topicConfiguration_filter,
    topicConfiguration_id,
    topicConfiguration_topicArn,
    topicConfiguration_events,

    -- ** Transition
    transition_date,
    transition_days,
    transition_storageClass,

    -- ** VersioningConfiguration
    versioningConfiguration_mfaDelete,
    versioningConfiguration_status,

    -- ** WebsiteConfiguration
    websiteConfiguration_errorDocument,
    websiteConfiguration_indexDocument,
    websiteConfiguration_redirectAllRequestsTo,
    websiteConfiguration_routingRules,
  )
where

import Amazonka.S3.AbortMultipartUpload
import Amazonka.S3.CompleteMultipartUpload
import Amazonka.S3.CopyObject
import Amazonka.S3.CreateBucket
import Amazonka.S3.CreateMultipartUpload
import Amazonka.S3.DeleteBucket
import Amazonka.S3.DeleteBucketAnalyticsConfiguration
import Amazonka.S3.DeleteBucketCors
import Amazonka.S3.DeleteBucketEncryption
import Amazonka.S3.DeleteBucketIntelligentTieringConfiguration
import Amazonka.S3.DeleteBucketInventoryConfiguration
import Amazonka.S3.DeleteBucketLifecycle
import Amazonka.S3.DeleteBucketMetricsConfiguration
import Amazonka.S3.DeleteBucketOwnershipControls
import Amazonka.S3.DeleteBucketPolicy
import Amazonka.S3.DeleteBucketReplication
import Amazonka.S3.DeleteBucketTagging
import Amazonka.S3.DeleteBucketWebsite
import Amazonka.S3.DeleteObject
import Amazonka.S3.DeleteObjectTagging
import Amazonka.S3.DeleteObjects
import Amazonka.S3.DeletePublicAccessBlock
import Amazonka.S3.GetBucketAccelerateConfiguration
import Amazonka.S3.GetBucketAcl
import Amazonka.S3.GetBucketAnalyticsConfiguration
import Amazonka.S3.GetBucketCors
import Amazonka.S3.GetBucketEncryption
import Amazonka.S3.GetBucketIntelligentTieringConfiguration
import Amazonka.S3.GetBucketInventoryConfiguration
import Amazonka.S3.GetBucketLifecycleConfiguration
import Amazonka.S3.GetBucketLocation
import Amazonka.S3.GetBucketLogging
import Amazonka.S3.GetBucketMetricsConfiguration
import Amazonka.S3.GetBucketNotificationConfiguration
import Amazonka.S3.GetBucketOwnershipControls
import Amazonka.S3.GetBucketPolicy
import Amazonka.S3.GetBucketPolicyStatus
import Amazonka.S3.GetBucketReplication
import Amazonka.S3.GetBucketRequestPayment
import Amazonka.S3.GetBucketTagging
import Amazonka.S3.GetBucketVersioning
import Amazonka.S3.GetBucketWebsite
import Amazonka.S3.GetObject
import Amazonka.S3.GetObjectAcl
import Amazonka.S3.GetObjectAttributes
import Amazonka.S3.GetObjectLegalHold
import Amazonka.S3.GetObjectLockConfiguration
import Amazonka.S3.GetObjectRetention
import Amazonka.S3.GetObjectTagging
import Amazonka.S3.GetObjectTorrent
import Amazonka.S3.GetPublicAccessBlock
import Amazonka.S3.HeadBucket
import Amazonka.S3.HeadObject
import Amazonka.S3.ListBucketAnalyticsConfigurations
import Amazonka.S3.ListBucketIntelligentTieringConfigurations
import Amazonka.S3.ListBucketInventoryConfigurations
import Amazonka.S3.ListBucketMetricsConfigurations
import Amazonka.S3.ListBuckets
import Amazonka.S3.ListMultipartUploads
import Amazonka.S3.ListObjectVersions
import Amazonka.S3.ListObjects
import Amazonka.S3.ListObjectsV2
import Amazonka.S3.ListParts
import Amazonka.S3.PutBucketAccelerateConfiguration
import Amazonka.S3.PutBucketAcl
import Amazonka.S3.PutBucketAnalyticsConfiguration
import Amazonka.S3.PutBucketCors
import Amazonka.S3.PutBucketEncryption
import Amazonka.S3.PutBucketIntelligentTieringConfiguration
import Amazonka.S3.PutBucketInventoryConfiguration
import Amazonka.S3.PutBucketLifecycleConfiguration
import Amazonka.S3.PutBucketLogging
import Amazonka.S3.PutBucketMetricsConfiguration
import Amazonka.S3.PutBucketNotificationConfiguration
import Amazonka.S3.PutBucketOwnershipControls
import Amazonka.S3.PutBucketPolicy
import Amazonka.S3.PutBucketReplication
import Amazonka.S3.PutBucketRequestPayment
import Amazonka.S3.PutBucketTagging
import Amazonka.S3.PutBucketVersioning
import Amazonka.S3.PutBucketWebsite
import Amazonka.S3.PutObject
import Amazonka.S3.PutObjectAcl
import Amazonka.S3.PutObjectLegalHold
import Amazonka.S3.PutObjectLockConfiguration
import Amazonka.S3.PutObjectRetention
import Amazonka.S3.PutObjectTagging
import Amazonka.S3.PutPublicAccessBlock
import Amazonka.S3.RestoreObject
import Amazonka.S3.SelectObjectContent
import Amazonka.S3.Types.AbortIncompleteMultipartUpload
import Amazonka.S3.Types.AccelerateConfiguration
import Amazonka.S3.Types.AccessControlPolicy
import Amazonka.S3.Types.AccessControlTranslation
import Amazonka.S3.Types.AnalyticsAndOperator
import Amazonka.S3.Types.AnalyticsConfiguration
import Amazonka.S3.Types.AnalyticsExportDestination
import Amazonka.S3.Types.AnalyticsFilter
import Amazonka.S3.Types.AnalyticsS3BucketDestination
import Amazonka.S3.Types.Bucket
import Amazonka.S3.Types.BucketLifecycleConfiguration
import Amazonka.S3.Types.BucketLoggingStatus
import Amazonka.S3.Types.CORSConfiguration
import Amazonka.S3.Types.CORSRule
import Amazonka.S3.Types.CSVInput
import Amazonka.S3.Types.CSVOutput
import Amazonka.S3.Types.Checksum
import Amazonka.S3.Types.CommonPrefix
import Amazonka.S3.Types.CompletedMultipartUpload
import Amazonka.S3.Types.CompletedPart
import Amazonka.S3.Types.Condition
import Amazonka.S3.Types.ContinuationEvent
import Amazonka.S3.Types.CopyObjectResult
import Amazonka.S3.Types.CopyPartResult
import Amazonka.S3.Types.CreateBucketConfiguration
import Amazonka.S3.Types.DefaultRetention
import Amazonka.S3.Types.Delete
import Amazonka.S3.Types.DeleteMarkerEntry
import Amazonka.S3.Types.DeleteMarkerReplication
import Amazonka.S3.Types.DeletedObject
import Amazonka.S3.Types.Destination
import Amazonka.S3.Types.Encryption
import Amazonka.S3.Types.EncryptionConfiguration
import Amazonka.S3.Types.EndEvent
import Amazonka.S3.Types.ErrorDocument
import Amazonka.S3.Types.EventBridgeConfiguration
import Amazonka.S3.Types.ExistingObjectReplication
import Amazonka.S3.Types.FilterRule
import Amazonka.S3.Types.GetObjectAttributesParts
import Amazonka.S3.Types.GlacierJobParameters
import Amazonka.S3.Types.Grant
import Amazonka.S3.Types.Grantee
import Amazonka.S3.Types.IndexDocument
import Amazonka.S3.Types.Initiator
import Amazonka.S3.Types.InputSerialization
import Amazonka.S3.Types.IntelligentTieringAndOperator
import Amazonka.S3.Types.IntelligentTieringConfiguration
import Amazonka.S3.Types.IntelligentTieringFilter
import Amazonka.S3.Types.InventoryConfiguration
import Amazonka.S3.Types.InventoryDestination
import Amazonka.S3.Types.InventoryEncryption
import Amazonka.S3.Types.InventoryFilter
import Amazonka.S3.Types.InventoryS3BucketDestination
import Amazonka.S3.Types.InventorySchedule
import Amazonka.S3.Types.JSONInput
import Amazonka.S3.Types.JSONOutput
import Amazonka.S3.Types.LambdaFunctionConfiguration
import Amazonka.S3.Types.LifecycleExpiration
import Amazonka.S3.Types.LifecycleRule
import Amazonka.S3.Types.LifecycleRuleAndOperator
import Amazonka.S3.Types.LifecycleRuleFilter
import Amazonka.S3.Types.LoggingEnabled
import Amazonka.S3.Types.MetadataEntry
import Amazonka.S3.Types.Metrics
import Amazonka.S3.Types.MetricsAndOperator
import Amazonka.S3.Types.MetricsConfiguration
import Amazonka.S3.Types.MetricsFilter
import Amazonka.S3.Types.MultipartUpload
import Amazonka.S3.Types.NoncurrentVersionExpiration
import Amazonka.S3.Types.NoncurrentVersionTransition
import Amazonka.S3.Types.NotificationConfiguration
import Amazonka.S3.Types.NotificationConfigurationFilter
import Amazonka.S3.Types.Object
import Amazonka.S3.Types.ObjectIdentifier
import Amazonka.S3.Types.ObjectLockConfiguration
import Amazonka.S3.Types.ObjectLockLegalHold
import Amazonka.S3.Types.ObjectLockRetention
import Amazonka.S3.Types.ObjectLockRule
import Amazonka.S3.Types.ObjectPart
import Amazonka.S3.Types.ObjectVersion
import Amazonka.S3.Types.OutputLocation
import Amazonka.S3.Types.OutputSerialization
import Amazonka.S3.Types.Owner
import Amazonka.S3.Types.OwnershipControls
import Amazonka.S3.Types.OwnershipControlsRule
import Amazonka.S3.Types.ParquetInput
import Amazonka.S3.Types.Part
import Amazonka.S3.Types.PolicyStatus
import Amazonka.S3.Types.Progress
import Amazonka.S3.Types.ProgressEvent
import Amazonka.S3.Types.PublicAccessBlockConfiguration
import Amazonka.S3.Types.QueueConfiguration
import Amazonka.S3.Types.RecordsEvent
import Amazonka.S3.Types.Redirect
import Amazonka.S3.Types.RedirectAllRequestsTo
import Amazonka.S3.Types.ReplicaModifications
import Amazonka.S3.Types.ReplicationConfiguration
import Amazonka.S3.Types.ReplicationRule
import Amazonka.S3.Types.ReplicationRuleAndOperator
import Amazonka.S3.Types.ReplicationRuleFilter
import Amazonka.S3.Types.ReplicationTime
import Amazonka.S3.Types.ReplicationTimeValue
import Amazonka.S3.Types.RequestPaymentConfiguration
import Amazonka.S3.Types.RequestProgress
import Amazonka.S3.Types.RestoreRequest
import Amazonka.S3.Types.RoutingRule
import Amazonka.S3.Types.S3KeyFilter
import Amazonka.S3.Types.S3Location
import Amazonka.S3.Types.S3ServiceError
import Amazonka.S3.Types.SSEKMS
import Amazonka.S3.Types.SSES3
import Amazonka.S3.Types.ScanRange
import Amazonka.S3.Types.SelectObjectContentEventStream
import Amazonka.S3.Types.SelectParameters
import Amazonka.S3.Types.ServerSideEncryptionByDefault
import Amazonka.S3.Types.ServerSideEncryptionConfiguration
import Amazonka.S3.Types.ServerSideEncryptionRule
import Amazonka.S3.Types.SourceSelectionCriteria
import Amazonka.S3.Types.SseKmsEncryptedObjects
import Amazonka.S3.Types.Stats
import Amazonka.S3.Types.StatsEvent
import Amazonka.S3.Types.StorageClassAnalysis
import Amazonka.S3.Types.StorageClassAnalysisDataExport
import Amazonka.S3.Types.Tag
import Amazonka.S3.Types.Tagging
import Amazonka.S3.Types.TargetGrant
import Amazonka.S3.Types.Tiering
import Amazonka.S3.Types.TopicConfiguration
import Amazonka.S3.Types.Transition
import Amazonka.S3.Types.VersioningConfiguration
import Amazonka.S3.Types.WebsiteConfiguration
import Amazonka.S3.UploadPart
import Amazonka.S3.UploadPartCopy
import Amazonka.S3.WriteGetObjectResponse
